import { Select } from "antd";
import { useEffect, useState } from "react";
import { useMutation } from "@apollo/client/react";
import { useTranslation } from "react-i18next";
import { connect } from "react-redux";
import { createStructuredSelector } from "reselect";
import { UPDATE_JOB_LINE } from "../../graphql/jobs-lines.queries";
import { selectBodyshop } from "../../redux/user/user.selectors";
import LoadingSpinner from "../loading-spinner/loading-spinner.component";
import { insertAuditTrail } from "../../redux/application/application.actions";
import AuditTrailMapping from "../../utils/AuditTrailMappings";
import { useNotification } from "../../contexts/Notifications/notificationContext.jsx";

const mapStateToProps = createStructuredSelector({
  //currentUser: selectCurrentUser
  bodyshop: selectBodyshop
});
const mapDispatchToProps = (dispatch) => ({
  insertAuditTrail: ({ jobid, operation }) => dispatch(insertAuditTrail({ jobid, operation }))
});

export function JoblineTeamAssignment({ bodyshop, jobline, disabled, jobId, insertAuditTrail }) {
  const [editing, setEditing] = useState(false);
  const [loading, setLoading] = useState(false);
  const [assignedTeam, setAssignedTeam] = useState(jobline.assigned_team);
  const [updateJob] = useMutation(UPDATE_JOB_LINE);
  const { t } = useTranslation();
  const notification = useNotification();

  useEffect(() => {
    if (editing) setAssignedTeam(jobline.assigned_team);
  }, [editing, jobline.assigned_team]);

  const handleChange = (e) => {
    setAssignedTeam(e);
  };

  const handleSave = async () => {
    setLoading(true);
    const result = await updateJob({
      variables: {
        lineId: jobline.id,
        line: { assigned_team: assignedTeam }
      }
    });

    if (!result.errors) {
      notification.success({ title: t("joblines.successes.saved") });
      //insert the audit trail here.
      const teamName = bodyshop.employee_teams.find((et) => et.id === assignedTeam)?.name;
      insertAuditTrail({
        jobid: jobId,
        operation: AuditTrailMapping.assignedlinehours(teamName, jobline.mod_lb_hrs)
      });
    } else {
      notification.error({
        title: t("joblines.errors.saving", {
          error: JSON.stringify(result.errors)
        })
      });
    }
    setLoading(false);
    setEditing(false);
  };

  if (editing)
    return (
      <div>
        <LoadingSpinner loading={loading}>
          <Select
            autoFocus
            allowClear
            popupMatchSelectWidth={100}
            value={assignedTeam}
            onSelect={handleChange}
            onBlur={handleSave}
            onClear={() => handleChange(null)}
            options={Object.values(bodyshop.employee_teams).map((s) => ({
              key: s.id,
              value: s.id,
              label: s.name
            }))}
          />
        </LoadingSpinner>
      </div>
    );

  const team = bodyshop.employee_teams.find((tm) => tm.id === jobline.assigned_team);

  return (
    <div style={{ width: "100%", minHeight: "1rem", cursor: "pointer" }} onClick={() => !disabled && setEditing(true)}>
      {team?.name}
    </div>
  );
}

export default connect(mapStateToProps, mapDispatchToProps)(JoblineTeamAssignment);
